Index: docs/intro/tutorial01.txt
===================================================================
--- docs/intro/tutorial01.txt	(revision 16215)
+++ docs/intro/tutorial01.txt	(working copy)
@@ -593,7 +593,7 @@
     Unicode string, and ``str(p)`` will return a normal string, with characters
     encoded as UTF-8.
 
-    If all of this is jibberish to you, just remember to add
+    If all of this is gibberish to you, just remember to add
     :meth:`~django.db.models.Model.__unicode__` methods to your models. With any
     luck, things should Just Work for you.
 
Index: docs/internals/svn.txt
===================================================================
--- docs/internals/svn.txt	(revision 16215)
+++ docs/internals/svn.txt	(working copy)
@@ -199,7 +199,7 @@
 fixes, and shortly after the release of Django 1.1 the branch
 ``django/branches/releases/1.1.X`` was created.
 
-Prior to the Django 1.0 release, these branches were maintaind within
+Prior to the Django 1.0 release, these branches were maintained within
 the top-level ``django/branches`` directory, and so the following
 branches exist there and provided support for older Django releases:
 
Index: docs/internals/contributing.txt
===================================================================
--- docs/internals/contributing.txt	(revision 16215)
+++ docs/internals/contributing.txt	(working copy)
@@ -472,7 +472,7 @@
     * Then, click the "Join this Team" button to become a member of this team.
       Every team has at least one coordinator who is responsible to review
       your membership request. You can of course also contact the team
-      coordinator to clarify procedual problems and handle the actual
+      coordinator to clarify procedural problems and handle the actual
       translation process.
 
     * Once you are a member of a team choose the translation resource you
Index: docs/internals/deprecation.txt
===================================================================
--- docs/internals/deprecation.txt	(revision 16215)
+++ docs/internals/deprecation.txt	(working copy)
@@ -20,7 +20,7 @@
 
     * 1.4
         * ``CsrfResponseMiddleware``.  This has been deprecated since the 1.2
-          release, in favour of the template tag method for inserting the CSRF
+          release, in favor of the template tag method for inserting the CSRF
           token.  ``CsrfMiddleware``, which combines ``CsrfResponseMiddleware``
           and ``CsrfViewMiddleware``, is also deprecated.
 
@@ -129,7 +129,7 @@
 
         * The undocumented function
           :func:`django.contrib.formtools.utils.security_hash`
-          is deprecated, in favour of :func:`django.contrib.formtools.utils.form_hmac`
+          is deprecated, in favor of :func:`django.contrib.formtools.utils.form_hmac`
 
         * The function-based generic views have been deprecated in
           favor of their class-based cousins. The following modules
@@ -161,7 +161,7 @@
           a :class:`~django.contrib.gis.geos.GEOSException` when called
           on a geometry with no SRID value.
 
-        * :class:`~django.http.CompatCookie` will be removed in favour of
+        * :class:`~django.http.CompatCookie` will be removed in favor of
           :class:`~django.http.SimpleCookie`.
 
         * :class:`django.core.context_processors.PermWrapper` and
Index: docs/howto/jython.txt
===================================================================
--- docs/howto/jython.txt	(revision 16215)
+++ docs/howto/jython.txt	(working copy)
@@ -65,7 +65,7 @@
 running on standard Python. However, are a few differences to keep in mind:
 
     * Remember to use the ``jython`` command instead of ``python``. The
-      documentation uses ``python`` for consistancy, but if you're using Jython
+      documentation uses ``python`` for consistency, but if you're using Jython
       you'll want to mentally replace ``python`` with ``jython`` every time it
       occurs.
 
Index: docs/howto/custom-template-tags.txt
===================================================================
--- docs/howto/custom-template-tags.txt	(revision 16215)
+++ docs/howto/custom-template-tags.txt	(working copy)
@@ -894,7 +894,7 @@
 .. admonition:: Variable scope in context
 
     Any variable set in the context will only be available in the same ``block``
-    of the template in which it was assigned. This behaviour is intentional;
+    of the template in which it was assigned. This behavior is intentional;
     it provides a scope for variables so that they don't conflict with
     context in other blocks.
 
Index: docs/howto/custom-management-commands.txt
===================================================================
--- docs/howto/custom-management-commands.txt	(revision 16215)
+++ docs/howto/custom-management-commands.txt	(working copy)
@@ -71,7 +71,7 @@
 <poll_id>``.
 
 The ``handle()`` method takes zero or more ``poll_ids`` and sets ``poll.opened``
-to ``False`` for each one. If the user referenced any nonexistant polls, a
+to ``False`` for each one. If the user referenced any nonexistent polls, a
 :class:`CommandError` is raised. The ``poll.opened`` attribute does not exist
 in the :doc:`tutorial</intro/tutorial01>` and was added to
 ``polls.models.Poll`` for this example.
Index: docs/howto/static-files.txt
===================================================================
--- docs/howto/static-files.txt	(revision 16215)
+++ docs/howto/static-files.txt	(working copy)
@@ -137,7 +137,7 @@
 directly in your templates. This means that a switch of static files servers
 only requires changing that single value. Much better!
 
-``staticfiles`` inludes two built-in ways of getting at this setting in your
+``staticfiles`` includes two built-in ways of getting at this setting in your
 templates: a context processor and a template tag.
 
 With a context processor
@@ -170,7 +170,7 @@
 every template. However, context processors require that you use
 :class:`~django.template.RequestContext` when rendering templates. This happens
 automatically if you're using a :doc:`generic view </ref/class-based-views>`,
-but in views written by hand you'll need to explicitally use ``RequestContext``
+but in views written by hand you'll need to explicitly use ``RequestContext``
 To see how that works, and to read more details, check out
 :ref:`subclassing-context-requestcontext`.
 
@@ -439,7 +439,7 @@
 
 Once that's done, all you have to do is run :djadmin:`collectstatic` and your
 static files would be pushed through your storage package up to S3. If you
-later needed to swich to a different storage provider, it could be as simple
+later needed to switch to a different storage provider, it could be as simple
 as changing your :setting:`STATICFILES_STORAGE` setting.
 
 For details on how you'd write one of these backends,
Index: docs/howto/error-reporting.txt
===================================================================
--- docs/howto/error-reporting.txt	(revision 16215)
+++ docs/howto/error-reporting.txt	(working copy)
@@ -44,7 +44,7 @@
    .. versionadded:: 1.3
 
    Server error emails are sent using the logging framework, so you can
-   customize this behaviour by :doc:`customizing your logging configuration
+   customize this behavior by :doc:`customizing your logging configuration
    </topics/logging>`.
 
 404 errors
Index: docs/topics/auth.txt
===================================================================
--- docs/topics/auth.txt	(revision 16215)
+++ docs/topics/auth.txt	(working copy)
@@ -283,7 +283,7 @@
         The :attr:`~django.contrib.auth.models.User.username` and
         :attr:`~django.contrib.auth.models.User.password` are set as given. The
         domain portion of :attr:`~django.contrib.auth.models.User.email` is
-        automatically convered to lowercase, and the returned
+        automatically converted to lowercase, and the returned
         :class:`~django.contrib.auth.models.User` object will have
         :attr:`~models.User.is_active` set to ``True``.
 
@@ -1244,7 +1244,7 @@
 :ref:`model Meta attribute <meta-options>`.
 
 This example Task model creates three custom permissions, i.e., actions users
-can or cannot do with Task instances, specific to your appication::
+can or cannot do with Task instances, specific to your application::
 
     class Task(models.Model):
         ...
Index: docs/topics/http/shortcuts.txt
===================================================================
--- docs/topics/http/shortcuts.txt	(revision 16215)
+++ docs/topics/http/shortcuts.txt	(working copy)
@@ -4,7 +4,7 @@
 
 .. module:: django.shortcuts
    :synopsis:
-       Convience shortcuts that spam multiple levels of Django's MVC stack.
+       Convenience shortcuts that spam multiple levels of Django's MVC stack.
 
 .. index:: shortcuts
 
Index: docs/topics/cache.txt
===================================================================
--- docs/topics/cache.txt	(revision 16215)
+++ docs/topics/cache.txt	(working copy)
@@ -615,7 +615,7 @@
 :ref:`respect the active language<i18n-cache-key>`. For the ``cache`` template
 tag you could use one of the
 :ref:`translation-specific variables<template-translation-vars>` available in
-templates to archieve the same result:
+templates to achieve the same result:
 
 .. code-block:: html+django
 
@@ -843,7 +843,7 @@
     # Version 2 isn't available, either
     >>> cache.get('my_key', version=2)
     None
-    # But version 3 *is* availble
+    # But version 3 *is* available
     >>> cache.get('my_key', version=3)
     'hello world!'
 
Index: docs/topics/db/models.txt
===================================================================
--- docs/topics/db/models.txt	(revision 16215)
+++ docs/topics/db/models.txt	(working copy)
@@ -188,7 +188,7 @@
 
         ::
 
-            >>> p = Person(name="Fred Flinstone", gender="M")
+            >>> p = Person(name="Fred Flintstone", gender="M")
             >>> p.save()
             >>> p.gender
             u'M'
@@ -791,7 +791,7 @@
  2. If you're subclassing an existing model (perhaps something from another
     application entirely) and want each model to have its own database table,
     :ref:`multi-table-inheritance` is the way to go.
- 3. Finally, if you only want to modify the Python-level behaviour of a model,
+ 3. Finally, if you only want to modify the Python-level behavior of a model,
     without changing the models fields in any way, you can use
     :ref:`proxy-models`.
 
@@ -1218,7 +1218,7 @@
 from that base class.
 
 Overriding fields in a parent model leads to difficulties in areas such as
-initialising new instances (specifying which field is being initialized in
+initializing new instances (specifying which field is being initialized in
 ``Model.__init__``) and serialization. These are features which normal Python
 class inheritance doesn't have to deal with in quite the same way, so the
 difference between Django model inheritance and Python class inheritance isn't
Index: docs/topics/db/aggregation.txt
===================================================================
--- docs/topics/db/aggregation.txt	(revision 16215)
+++ docs/topics/db/aggregation.txt	(working copy)
@@ -233,7 +233,7 @@
 publisher; the second query will only include good books in the annotated
 count. In the first query, the annotation precedes the filter, so the
 filter has no effect on the annotation. In the second query, the filter
-preceeds the annotation, and as a result, the filter constrains the objects
+precedes the annotation, and as a result, the filter constrains the objects
 considered when calculating the annotation.
 
 ``order_by()``
Index: docs/topics/class-based-views.txt
===================================================================
--- docs/topics/class-based-views.txt	(revision 16215)
+++ docs/topics/class-based-views.txt	(working copy)
@@ -72,7 +72,7 @@
 
 Then, we just need to add this new view into our URLconf. As the class-based
 views themselves are classes, we point the URL to the as_view class method
-instead, which is the entrypoint for class-based views::
+instead, which is the entry point for class-based views::
 
     # urls.py
     from django.conf.urls.defaults import *
Index: docs/topics/testing.txt
===================================================================
--- docs/topics/testing.txt	(revision 16215)
+++ docs/topics/testing.txt	(working copy)
@@ -95,7 +95,7 @@
 
         import unittest
 
-    If you want to continue to use the base unittest libary, you can --
+    If you want to continue to use the base unittest library, you can --
     you just won't get any of the nice new unittest2 features.
 
 .. _unittest2: http://pypi.python.org/pypi/unittest2
Index: docs/topics/logging.txt
===================================================================
--- docs/topics/logging.txt	(revision 16215)
+++ docs/topics/logging.txt	(working copy)
@@ -156,7 +156,7 @@
 some other way of organizing your logging messages, you can provide
 any dot-separated name to identify your logger::
 
-    # Get an instance of a specfic named logger
+    # Get an instance of a specific named logger
     logger = logging.getLogger('project.interesting.stuff')
 
 The dotted paths of logger names define a hierarchy. The
Index: docs/topics/signals.txt
===================================================================
--- docs/topics/signals.txt	(revision 16215)
+++ docs/topics/signals.txt	(working copy)
@@ -106,7 +106,7 @@
 Connecting receiver functions
 -----------------------------
 
-There are two ways you can connect a receiever to a signal. You can take the
+There are two ways you can connect a receiver to a signal. You can take the
 manual connect route:
 
 .. code-block:: python