diff --git a/django/contrib/admin/media/img/admin/selector-remove.gif b/django/contrib/admin/media/img/admin/selector-remove.gif
index 2b9b0a2ac35a2051834bb9a49a7d57aaeebdcb48..6c5d45ae6e7722a0f0c568a20c21458bb1cc2f99 100644
GIT binary patch
diff --git a/django/contrib/admin/media/img/admin/selector-removeall.gif b/django/contrib/admin/media/img/admin/selector-removeall.gif
index 5a4421926d9c352abcf3b114ccd296197b9c9fdf..28b4fad628aabdf644d01457404c81577a44d42b 100644
GIT binary patch
diff --git a/django/contrib/admin/media/img/admin/selector_stacked-remove.gif b/django/contrib/admin/media/img/admin/selector_stacked-remove.gif
index 60412cee19c6b5d2ff5d1f86f765988ddddbb6dc..aa8b67f90449c32d7b52bd4bb352940ca6a7f7a8 100644
GIT binary patch
diff --git a/django/contrib/admin/media/js/SelectFilter2.js b/django/contrib/admin/media/js/SelectFilter2.js
index 92eff2ecfa7536b865fee5c140d90e2a26a46cb2..fcd5f03ec5a5ac7fbd729fbc4e97e3981ef1534a 100644
--- a/django/contrib/admin/media/js/SelectFilter2.js
+++ b/django/contrib/admin/media/js/SelectFilter2.js
@@ -57,6 +57,11 @@ var SelectFilter = {
 
         var filter_input = quickElement('input', filter_p, '', 'type', 'text');
         filter_input.id = field_id + '_input';
+        
+        var selector_filter_available = quickElement('p', selector_available, gettext('To add, select your choice(s) and click '));
+        selector_filter_available.className = 'selector-filter';
+        quickElement('img', selector_filter_available, '', 'src', admin_media_prefix + (is_stacked ? 'img/admin/selector_stacked-add.gif':'img/admin/selector-add.gif'), 'alt', 'Add');
+        
         selector_available.appendChild(from_box);
         var choose_all = quickElement('a', selector_available, gettext('Choose all'), 'href', 'javascript: (function(){ SelectBox.move_all("' + field_id + '_from", "' + field_id + '_to"); })()');
         choose_all.className = 'selector-chooseall';
@@ -73,9 +78,9 @@ var SelectFilter = {
         var selector_chosen = quickElement('div', selector_div, '');
         selector_chosen.className = 'selector-chosen';
         quickElement('h2', selector_chosen, interpolate(gettext('Chosen %s'), [field_name]));
-        var selector_filter = quickElement('p', selector_chosen, gettext('Select your choice(s) and click '));
-        selector_filter.className = 'selector-filter';
-        quickElement('img', selector_filter, '', 'src', admin_media_prefix + (is_stacked ? 'img/admin/selector_stacked-add.gif':'img/admin/selector-add.gif'), 'alt', 'Add');
+        var selector_filter_chosen = quickElement('p', selector_chosen, gettext('To remove, select your choice(s) and click '));
+        selector_filter_chosen.className = 'selector-filter';
+        quickElement('img', selector_filter_chosen, '', 'src', admin_media_prefix + (is_stacked ? 'img/admin/selector_stacked-remove.gif':'img/admin/selector-remove.gif'), 'alt', 'Add');
         var to_box = quickElement('select', selector_chosen, '', 'id', field_id + '_to', 'multiple', 'multiple', 'size', from_box.size, 'name', from_box.getAttribute('name'));
         to_box.className = 'filtered';
         var clear_all = quickElement('a', selector_chosen, gettext('Clear all'), 'href', 'javascript: (function() { SelectBox.move_all("' + field_id + '_to", "' + field_id + '_from");})()');