diff --git a/docs/faq/contributing.txt b/docs/faq/contributing.txt
index 81c06f3..2cf4ddd 100644
--- a/docs/faq/contributing.txt
+++ b/docs/faq/contributing.txt
@@ -5,7 +5,7 @@ How can I get started contributing code to Django?
 --------------------------------------------------
 
 Thanks for asking! We've written an entire document devoted to this question.
-It's titled :doc:`Contributing to Django </internals/contributing>`.
+It's titled :doc:`Contributing to Django </internals/contributing/index>`.
 
 I submitted a bug fix in the ticket system several weeks ago. Why are you ignoring my patch?
 --------------------------------------------------------------------------------------------
diff --git a/docs/internals/svn.txt b/docs/internals/svn.txt
index 58cabd1..b499386 100644
--- a/docs/internals/svn.txt
+++ b/docs/internals/svn.txt
@@ -86,7 +86,7 @@ the ``django`` module within your checkout.
 If you're going to be working on Django's code (say, to fix a bug or
 develop a new feature), you can probably stop reading here and move
 over to :doc:`the documentation for contributing to Django
-</internals/contributing>`, which covers things like the preferred
+</internals/contributing/index>`, which covers things like the preferred
 coding style and how to generate and submit a patch.
 
 
diff --git a/docs/ref/contrib/webdesign.txt b/docs/ref/contrib/webdesign.txt
index d355d03..ded878d 100644
--- a/docs/ref/contrib/webdesign.txt
+++ b/docs/ref/contrib/webdesign.txt
@@ -13,7 +13,7 @@ developers).
 
 At present, the package contains only a single template tag. If you have ideas
 for Web-designer-friendly functionality in Django, please
-:doc:`suggest them </internals/contributing>`.
+:doc:`suggest them </internals/contributing/index>`.
 
 Template tags
 =============
diff --git a/docs/releases/1.0-alpha-1.txt b/docs/releases/1.0-alpha-1.txt
index 82846be..2b6d5cd 100644
--- a/docs/releases/1.0-alpha-1.txt
+++ b/docs/releases/1.0-alpha-1.txt
@@ -154,7 +154,7 @@ to join the discussions there.
 Django's online documentation also includes pointers on how to
 contribute to Django:
 
-    :doc:`contributing to Django </internals/contributing>`
+    :doc:`contributing to Django </internals/contributing/index>`
 
 Contributions on any level -- developing code, writing
 documentation or simply triaging tickets and helping to test proposed
diff --git a/docs/releases/1.0-alpha-2.txt b/docs/releases/1.0-alpha-2.txt
index 83e2e2e..54876bf 100644
--- a/docs/releases/1.0-alpha-2.txt
+++ b/docs/releases/1.0-alpha-2.txt
@@ -129,7 +129,7 @@ to join the discussions there.
 Django's online documentation also includes pointers on how to
 contribute to Django:
 
-    :doc:`contributing to Django </internals/contributing>`
+    :doc:`contributing to Django </internals/contributing/index>`
 
 Contributions on any level -- developing code, writing
 documentation or simply triaging tickets and helping to test proposed
diff --git a/docs/releases/1.0-beta-2.txt b/docs/releases/1.0-beta-2.txt
index eabd6b7..1ee75c7 100644
--- a/docs/releases/1.0-beta-2.txt
+++ b/docs/releases/1.0-beta-2.txt
@@ -112,7 +112,7 @@ to join the discussions there.
 Django's online documentation also includes pointers on how to
 contribute to Django:
 
-    :doc:`contributing to Django </internals/contributing>`
+    :doc:`contributing to Django </internals/contributing/index>`
 
 Contributions on any level -- developing code, writing
 documentation or simply triaging tickets and helping to test proposed
diff --git a/docs/releases/1.0-beta.txt b/docs/releases/1.0-beta.txt
index 9e07e6c..5e9d297 100644
--- a/docs/releases/1.0-beta.txt
+++ b/docs/releases/1.0-beta.txt
@@ -146,7 +146,7 @@ to join the discussions there.
 Django's online documentation also includes pointers on how to
 contribute to Django:
 
-    :doc:`contributing to Django </internals/contributing>`
+    :doc:`contributing to Django </internals/contributing/index>`
 
 Contributions on any level -- developing code, writing
 documentation or simply triaging tickets and helping to test proposed
diff --git a/docs/releases/1.1-alpha-1.txt b/docs/releases/1.1-alpha-1.txt
index b15a2a4..49f989a 100644
--- a/docs/releases/1.1-alpha-1.txt
+++ b/docs/releases/1.1-alpha-1.txt
@@ -151,7 +151,7 @@ discussions there.
 Django's online documentation also includes pointers on how to contribute to
 Django:
 
-    * :doc:`How to contribute to Django </internals/contributing>`
+    * :doc:`How to contribute to Django </internals/contributing/index>`
 
 Contributions on any level -- developing code, writing documentation or simply
 triaging tickets and helping to test proposed bugfixes -- are always welcome and
diff --git a/docs/releases/1.1-beta-1.txt b/docs/releases/1.1-beta-1.txt
index 535f818..fbecbbb 100644
--- a/docs/releases/1.1-beta-1.txt
+++ b/docs/releases/1.1-beta-1.txt
@@ -196,7 +196,7 @@ discussions there.
 Django's online documentation also includes pointers on how to contribute to
 Django:
 
-    * :doc:`How to contribute to Django </internals/contributing>`
+    * :doc:`How to contribute to Django </internals/contributing/index>`
 
 Contributions on any level -- developing code, writing documentation or simply
 triaging tickets and helping to test proposed bugfixes -- are always welcome and
diff --git a/docs/releases/1.1-rc-1.txt b/docs/releases/1.1-rc-1.txt
index f74444f..cb2aac6 100644
--- a/docs/releases/1.1-rc-1.txt
+++ b/docs/releases/1.1-rc-1.txt
@@ -102,7 +102,7 @@ discussions there.
 Django's online documentation also includes pointers on how to contribute to
 Django: 
 
-    * :doc:`How to contribute to Django </internals/contributing>`
+    * :doc:`How to contribute to Django </internals/contributing/index>`
 
 Contributions on any level -- developing code, writing documentation or simply
 triaging tickets and helping to test proposed bugfixes -- are always welcome and
diff --git a/docs/releases/1.1.txt b/docs/releases/1.1.txt
index 3ca8344..987bbd7 100644
--- a/docs/releases/1.1.txt
+++ b/docs/releases/1.1.txt
@@ -454,7 +454,7 @@ join the discussions!
 Django's online documentation also includes pointers on how to contribute to
 Django:
 
-    * :doc:`How to contribute to Django </internals/contributing>`
+    * :doc:`How to contribute to Django </internals/contributing/index>`
 
 Contributions on any level -- developing code, writing documentation or simply
 triaging tickets and helping to test proposed bugfixes -- are always welcome and
diff --git a/docs/releases/1.2-alpha-1.txt b/docs/releases/1.2-alpha-1.txt
index e656843..c24fd7a 100644
--- a/docs/releases/1.2-alpha-1.txt
+++ b/docs/releases/1.2-alpha-1.txt
@@ -576,7 +576,7 @@ discussions there.
 Django's online documentation also includes pointers on how to contribute to
 Django:
 
-    * :doc:`How to contribute to Django </internals/contributing>`
+    * :doc:`How to contribute to Django </internals/contributing/index>`
 
 Contributions on any level -- developing code, writing documentation or simply
 triaging tickets and helping to test proposed bugfixes -- are always welcome and
diff --git a/docs/releases/1.2-beta-1.txt b/docs/releases/1.2-beta-1.txt
index 2a12ef3..c24470e 100644
--- a/docs/releases/1.2-beta-1.txt
+++ b/docs/releases/1.2-beta-1.txt
@@ -161,7 +161,7 @@ discussions there.
 Django's online documentation also includes pointers on how to
 contribute to Django:
 
-    * :doc:`How to contribute to Django </internals/contributing>`
+    * :doc:`How to contribute to Django </internals/contributing/index>`
 
 Contributions on any level -- developing code, writing documentation
 or simply triaging tickets and helping to test proposed bugfixes --
diff --git a/docs/releases/1.2-rc-1.txt b/docs/releases/1.2-rc-1.txt
index b599dcc..62701e0 100644
--- a/docs/releases/1.2-rc-1.txt
+++ b/docs/releases/1.2-rc-1.txt
@@ -94,7 +94,7 @@ discussions there.
 Django's online documentation also includes pointers on how to contribute to
 Django: 
 
-    * :doc:`How to contribute to Django </internals/contributing>`
+    * :doc:`How to contribute to Django </internals/contributing/index>`
 
 Contributions on any level -- developing code, writing documentation or simply
 triaging tickets and helping to test proposed bugfixes -- are always welcome and
diff --git a/docs/releases/1.3-alpha-1.txt b/docs/releases/1.3-alpha-1.txt
index d6610d1..ed2ba36 100644
--- a/docs/releases/1.3-alpha-1.txt
+++ b/docs/releases/1.3-alpha-1.txt
@@ -392,7 +392,7 @@ discussions there.
 Django's online documentation also includes pointers on how to contribute to
 Django:
 
-    * :doc:`How to contribute to Django </internals/contributing>`
+    * :doc:`How to contribute to Django </internals/contributing/index>`
 
 Contributions on any level -- developing code, writing documentation or simply
 triaging tickets and helping to test proposed bugfixes -- are always welcome and
diff --git a/docs/releases/1.3-beta-1.txt b/docs/releases/1.3-beta-1.txt
index 0210ada..5e3f967 100644
--- a/docs/releases/1.3-beta-1.txt
+++ b/docs/releases/1.3-beta-1.txt
@@ -226,7 +226,7 @@ discussions there.
 Django's online documentation also includes pointers on how to contribute to
 Django:
 
-    * :doc:`How to contribute to Django </internals/contributing>`
+    * :doc:`How to contribute to Django </internals/contributing/index>`
 
 Contributions on any level -- developing code, writing documentation or simply
 triaging tickets and helping to test proposed bugfixes -- are always welcome and
diff --git a/docs/topics/http/middleware.txt b/docs/topics/http/middleware.txt
index 56dda42..c9c2311 100644
--- a/docs/topics/http/middleware.txt
+++ b/docs/topics/http/middleware.txt
@@ -210,4 +210,4 @@ Guidelines
 
     * If you write a middleware component that you think would be useful to
       other people, contribute to the community! :doc:`Let us know
-      </internals/contributing>`, and we'll consider adding it to Django.
+      </internals/contributing/index>`, and we'll consider adding it to Django.